# SourcePath: libcurl/20171120dev
Summary: Client-side URL utility
Name: sony-target-dev-libcurl
%define pkgname %{sony_tool_triplet}-%{sony_target_dialect}-dev-libcurl
Version: 7.42.1
Release: 08020505
Source: curl-%{version}.tar.bz2
Source1: ca-bundle.crt
# LOT scripts
Source10: sony-libcurl-libopt-build-libcurl
Patch1:  libcurl-7.42.1-test1086.patch
Patch2:  libcurl-7.42.1-test1903.patch
Patch3:  libcurl-7.42.1-test1135.patch
Patch4:  uploadbuffer.patch
Patch5:  EJ_replace_buffer.patch
Patch6:  libcurl-7.42.1-CVE-2015-3236.patch
Patch7:  libcurl-7.42.1-CVE-2015-3237.patch
Patch8:  libcurl-7.42.1-CVE-2016-0755.patch
Patch9:  libcurl-7.42.1-CVE-2016-5419.patch
Patch10: libcurl-7.42.1-CVE-2016-5420.patch
Patch11: libcurl-7.42.1-CVE-2016-5421.patch
Patch12: libcurl-7.42.1-CVE-2016-7141.patch
Patch13: libcurl-7.42.1-CVE-2016-7167.patch
Patch14: libcurl-7.42.1-CVE-2016-8615.patch
Patch15: libcurl-7.42.1-CVE-2016-8616.patch
Patch16: libcurl-7.42.1-CVE-2016-8617.patch
Patch17: libcurl-7.42.1-CVE-2016-8618.patch
Patch18: libcurl-7.42.1-CVE-2016-8619.patch
Patch19: libcurl-7.42.1-CVE-2016-8620.patch
Patch20: libcurl-7.42.1-CVE-2016-8621.patch
Patch21: libcurl-7.42.1-CVE-2016-8622.patch
Patch22: libcurl-7.42.1-CVE-2016-8623.patch
Patch23: libcurl-7.42.1-CVE-2016-8624.patch
Patch24: libcurl-7.42.1-CVE-2016-9586.patch
Patch25: libcurl-7.42.1-CVE-2017-7407.patch
Patch26: libcurl-7.42.1-CVE-2017-1000100.patch
Patch27: libcurl-7.42.1-CVE-2017-1000101.patch
Patch28: libcurl-7.42.1-CVE-2017-1000254.patch
Patch29: libcurl-7.42.1-CVE-2017-1000257.patch

Url: http://curl.haxx.se/
License: Other
Distribution: %{sony_distribution}
Vendor: %{sony_vendor}
Packager: %{sony_packager}
Group: %{sony_group}
Buildroot: %{_tmppath}/%{name}-root
%define targetroot %{sony_target_dir}
Prefix: %{sony_target_dir}
BuildRequires: %{sony_tool_triplet}-%{sony_target_dialect}-dev-zlib

%description
libcurl is a library implementing the client-side URL transfers.
This package includes the shared library.

%package -n %{pkgname}
Summary: CURL library - runtime
Group: %{sony_group}
AutoReqProv: no

%description -n %{pkgname}
libcurl is a library implementing the client-side URL transfers.
This package includes the shared library.

%prep
%setup -n curl-%{version} -q
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1
%patch16 -p1
%patch17 -p1
%patch18 -p1
%patch19 -p1
%patch20 -p1
%patch21 -p1
%patch22 -p1
%patch23 -p1
%patch24 -p1
%patch25 -p1
%patch26 -p1
%patch27 -p1
%patch28 -p1
%patch29 -p1

cp %{SOURCE1} lib

%build
%sony_target_dev_setup
%demangle_XXX_config
ac_cv_func_SSLv2_client_method=no
%sony_target_dev_configure \
	--enable-ipv6 \
	--with-random \
	--with-libssh2 \
	--with-ca-bundle=%{sony_target_dev_local_dir}/share/curl/curl-ca-bundle.crt
make CFLAGS="-O2 -DHAVE_GETADDRINFO -ffunction-sections"

%install
rm -rf %{buildroot}
%sony_target_dev_setup
%sony_target_dev_makeinstall

mkdir -p  %{buildroot}%{sony_target_dir}%{sony_target_dev_local_dir}/share/curl

install -m 644 ../lib/ca-bundle.crt %{buildroot}%{sony_target_dir}%{sony_target_dev_local_dir}/share/curl/curl-ca-bundle.crt

rm -rf %{buildroot}%{sony_target_dir}%{sony_target_dev_man_dir}/
rm -rf %{buildroot}%{sony_target_dir}%{sony_target_dev_data_dir}/

# Begin for LOT
mkdir -p %{buildroot}%{sony_target_dir}/lib
mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_devtool_lib_dir}/optinfo/libcurl

# Set Library Optimizer variables
%define _optdir %{buildroot}%{sony_target_dir}%{sony_target_devtool_lib_dir}/optinfo
%define _rootlibdir %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}

# Install Library Optimizer information (libcurl)
install -m 755 %{SOURCE10} %{_optdir}/libcurl/build
install -m 644 lib/.libs/*.o %{_optdir}/libcurl/

(cd %{_optdir}/libcurl; umask 022; %{sony_cross_bin_dir}/%{sony_tool_triplet}-libindex %{_rootlibdir}/libcurl.so -o *.o > index)
(umask 022; echo "/usr/lib/libcurl.so.4" > %{_optdir}/libcurl/path)

%demangle_libtool

# 6.x
for b in `ls %{buildroot}%{sony_target_dir}%{sony_target_dev_bin_dir}`; do
    case $b in
        *-config)
          mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_devtool_bin_dir}
          mv %{buildroot}%{sony_target_dir}%{sony_target_dev_bin_dir}/$b \
             %{buildroot}%{sony_target_dir}%{sony_target_devtool_bin_dir}
          ;;
    esac
done

for l in `ls %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}`; do
    case $l in
        *.a|pkgconfig)
          mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_devtool_lib_dir}
          mv %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}/$l \
             %{buildroot}%{sony_target_dir}%{sony_target_devtool_lib_dir}
          ;;
    esac
done

for l in `ls %{buildroot}%{sony_target_dir}%{sony_target_devtool_lib_dir}`; do
    if [ "$l" != "pkgconfig" -a "$l" != "optinfo" ]; then
        ln -s ../..%{sony_target_devtool_lib_dir}/$l \
            %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}/$l
    fi
done

%clean
rm -rf ${RPM_BUILD_ROOT}


%files -n %{pkgname}
%defattr(-,root,root)
%{sony_target_dir}%{sony_target_dev_bin_dir}/curl
%{sony_target_dir}%{sony_target_dev_include_dir}/curl/*.h
%{sony_target_dir}%{sony_target_dev_lib_dir}/libcurl.so*
%{sony_target_dir}%{sony_target_dev_lib_dir}/libcurl.la
%{sony_target_dir}%{sony_target_dev_lib_dir}/libcurl.a
%{sony_target_dir}%{sony_target_dev_local_dir}/share/curl/curl-ca-bundle.crt

# for LOT
%{sony_target_dir}%{sony_target_devtool_lib_dir}/optinfo/*

%{sony_target_dir}%{sony_target_devtool_lib_dir}/libcurl.a
%{sony_target_dir}%{sony_target_devtool_bin_dir}/curl-config
%{sony_target_dir}%{sony_target_devtool_lib_dir}/pkgconfig/libcurl.pc

%changelog
*Mon Nov 20 2017 Sony Corporation
- Added EJ_replace_buffer.patch,
  Added CVE-2015-3236,CVE-2015-3237,CVE-2016-0755,CVE-2016-5419,
  CVE-2016-5420,CVE-2016-5421,CVE-2016-7141,CVE-2016-7167,CVE-2016-8615,
  CVE-2016-8616,CVE-2016-8617,CVE-2016-8618,CVE-2016-8619,CVE-2016-8620,
  CVE-2016-8621,CVE-2016-8622,CVE-2016-8623,CVE-2016-8624,CVE-2016-9586,
  CVE-2017-7407,CVE-2017-1000100,CVE-2017-1000101,CVE-2017-1000254,
  CVE-2017-1000257 fix patches.

* Wed Nov 23 2016 Sony Corporation
- Added uploadbuffer patch and libcurl-7.42.1-test1135.patch

* Fri Mar 18 2016 Sony Corporation
- Disable SSLv2_client_method for disable SSLv2 from openssl

* Thu Jan 07 2016 Sony Corporation
- Added libcurl version 7.42.1
